////////////////////////////////////////
// 49104 v.4 opg.1
//
// Pythagoraiske tripler
//

/*
Dette program finder pythagoras-tripler (hele tal, der passer i pythagoras stning).

a^2 + b^2 = c^2

Algoritmen er en variant af Erastothenes si til sgning af primtal - 
der anvendes en 2-dimensionel tabel af boolean, hvori parret af de to frste tal (a og b) markeres
som brugt, samt alle multipla af a*N og b*N, hvor N er alle hele tal. Ex:

a=3, b=4 findes:

[3,4]=sand
[6,8]=sand ( da (2*3)^2 + (2*4)^2 = (2*5)^2 )
[9,12]=sand ( da (3*3)^2 + (3*4)^2 = (3*5)^2 )
.
.
.

efter markering af serien, sges efter det nste nye par, der ikke er markeret i tabellen.
Ulempen ved denne metode er den store to-dimensionelle tabel - vil du finde alle pythagoriske tripler
mellem 1 og 2000 fylder tabellen i lageret 2000*2000 = 4 MB!

Der findes yderligere en algoritme heri - 
Euklids(?) strste flles divisor.
For at sortere multipla ud, kan man istedet for den temmelig hukommelseskrvende metode ovenfor
istedet se om talparret har flles divisorer - hvis de ikke er inbyrdes primiske (har en flles divisor
forskellig fra 1) skal de ikke udskrives igen. Dette er den algoritme, TD har anvendt i hans lsningsforslag.

*/

class Pythagoras
{
	public static final int MAX = 2000;
	public static int greatestcommondivisor(int a, int b)
	{
		int t=0;
		
		if ( (a==0) || (b==0) )
		{
			return -1;
		}
		
		if (a>b) 
		{
			t=b;
			b=a;
			a=t;
		}
		// b strre end a, 
		
		/*
			repeat_div
			lad det vi dividerer vre det vi brugte som nvner sidste gang
			lad resten af sidste division vre det vi dividere med denne gang
			gennemfr division
			hvis det gik op, da afbryd - det vi dividerede med er da strste flles divisor.
		*/

		// Euklids algoritme, der virker...:)
		int c=b, d=a;
		do 
		{
			b=c; 
			a=d;
			c=a;
			d=b%a;
		} while (d!=0);
		return a;		
		
	}


	
	public static void main(String[] args)
	{
		boolean alreadychecked[][] = new boolean[MAX+1][MAX+1];
		double sqrt=0.0;
		int count=0;
		
		for (int a=1; a<=MAX; a++)
			for (int b=a; b<=MAX; b++)
				if (!alreadychecked[a][b])
				{
					sqrt = Math.sqrt(a*a+b*b);
					if (sqrt==(int)sqrt)
					{
						System.out.println("["+ (++count) +"] \t"+a+"\t"+b+"\t"+(int)sqrt+"\t\t"+greatestcommondivisor(a,b));
						if (a>1)
							for (int i=2; i<=MAX/a; i++)
								if ((a*i<=MAX) && (b*i<=MAX) )
									alreadychecked[a*i][b*i]=true;
					}
				}
		System.out.println("Ialt: "+count);
		
	}


}
