////////////////////////////////////////
// 49104 v.10 opg.1
//
// Frame med menuer

import java.awt.*;
import java.awt.event.*;

public class MenuTestFrame extends Frame implements ActionListener
{
	private String sFontItems[] = { "Serif", "SansSerif", "Monospaced" };
	private String sTypeItems[] = { "Normal", "Bold", "Italic", "Bold-Italic" };
	private String sSizeItems[] = { "10","12","14","20","36"};
	private String sColorItems[] = { "Sort", "Bl", "Cyan", "Mrkegr", "Gr", "Lysegr", "Magenta", "Orange", "Lyserd", "Rd", "Hvid", "Gul" };
	private Color cColorItems[] = { Color.black, Color.blue, Color.cyan, Color.darkGray, Color.gray, Color.lightGray, Color.magenta, Color.orange, Color.pink, Color.red, Color.white, Color.yellow };

	private TextArea taUserText = new TextArea( "Indtast din tekst her" , 10,10, TextArea.SCROLLBARS_VERTICAL_ONLY);
	private Font CurrentFont = new Font("SansSerif", Font.PLAIN, 10 );


	private MenuBar menubar = new MenuBar();
	private Menu fontmenu = new Menu("Skrifttype");
	private Menu typemenu = new Menu("Art");
	private Menu sizecolormenu = new Menu("Strrelse-Farve");
	private Menu colormenu = new Menu("Farve");
	private Menu help = new Menu("Hjlp");
	private MenuItem about = new MenuItem("Om...");
	private MenuItem miFontItems[] = new MenuItem[ sFontItems.length ];
	private MenuItem miTypeItems[] = new MenuItem[ sTypeItems.length ];
	private MenuItem miSizeItems[] = new MenuItem[ sSizeItems.length ];
	private MenuItem miColorItems[] = new MenuItem[ sColorItems.length ];


	public MenuTestFrame()
	{
		super( "MenuTest - rammen!" );
		setSize( 400, 200 );

		createmenu( fontmenu, sFontItems, miFontItems );
		createmenu( typemenu, sTypeItems, miTypeItems );
		createmenu( colormenu, sColorItems, miColorItems );
		sizecolormenu.add( colormenu );
		sizecolormenu.addSeparator();
		createmenu( sizecolormenu, sSizeItems, miSizeItems );
		help.add( about );
		about.addActionListener( this );

		menubar.add( fontmenu );
		menubar.add( typemenu );
		menubar.add( sizecolormenu );
		menubar.add( help );

		setMenuBar( menubar );
		add( taUserText );
		taUserText.setFont( CurrentFont );
		
		setVisible(true);
	}

	private void createmenu( Menu menu, String names[], MenuItem items[] )
	{

		for (int lp1=0; lp1<names.length; lp1++)
		{
			items[lp1] = new MenuItem( names[lp1] );
			items[lp1].addActionListener( this );
			menu.add( items[lp1] );
		}
	}


	public void actionPerformed( ActionEvent e )
	{
		Font c = CurrentFont;
		Font d = null;

		if (e.getSource() == about)
		{
			taUserText.setText("Dette program blev hndkodet af Mikael og Rune");
		}
		// Led efter font-menuitem
		for (int lp1=0; lp1<miFontItems.length; lp1++ )
			if ( e.getSource() == miFontItems[lp1] )
			{
				d = new Font( e.getActionCommand(), c.getStyle(),  c.getSize() );
				CurrentFont = d;
				d=null;
				taUserText.setFont( CurrentFont );
			}

		// Led efter strrelse
		for (int lp1=0; lp1<miSizeItems.length; lp1++ )
			if ( e.getSource() == miSizeItems[lp1] )
			{
				d = new Font( c.getName(), c.getStyle(), Integer.parseInt(e.getActionCommand()) );
				CurrentFont = d;
				d=null;
				taUserText.setFont( CurrentFont );
			}

		// Led efter style
		for (int lp1=0; lp1<miTypeItems.length; lp1++ )
			if ( e.getSource() == miTypeItems[lp1] )
			{
				int s = 0;

				switch (lp1)
				{
					case 0 : s = Font.PLAIN; break;
					case 1 : s = Font.BOLD; break;
					case 2 : s = Font.ITALIC; break;
					case 3 : s = Font.ITALIC + Font.BOLD; break;
					default : s=Font.PLAIN; break;
				}

				d = new Font( c.getName(), s, c.getSize() );
				CurrentFont = d;
				d=null;
				taUserText.setFont( CurrentFont );
			}

		// Led efter farve
		for (int lp1=0; lp1<miColorItems.length; lp1++ )
			if ( e.getSource() == miColorItems[lp1] )
			{
				taUserText.setForeground(cColorItems[lp1]);
			}
}

}
