////////////////////////////////////////
// 49104 v.11 alle opgaver
//
// Rekursion

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/*
Eksempel p optimering af rekursion ved dynamisk programmering:

Ved at notere resultatet af en beregning p en rekursiv funktion i en tabel, kan man reducere overhead
ved rekursiv beregning enormt. Ex.:


fibonaccis talflge:

def: f(n) = f(n-1) + f(n-2), hvor n>1 ellers: f(1)=1, f(0)=1

Beregning rekursivt i computer:

f(4) = f(3) + f(2)
	f(3) = f(2) + f(1)
		f(2) = f(1) + f(0)
			f(1) = 1
			f(0) = 1
		f(2) = 1+1 = 2
		f(1) = 1
	f(3) = 2+1 = 3
	f(2) = f(1) + f(0)
		f(1) = 1
		f(0) = 1
	f(2) = 1+1 = 2
f(4) = 3+2


Som man allerede her kan se, vil beregningen op til flere gange kalde den samme funktion med de samme
parametre (se bare at f(2) kaldes 2 gange - overvej hvor mange gange det bliver for f(23)!). Ideen
er at man lagrer beregningsresultater i en tabel, som man slr op i, i stedet for at beregne igen!.
Da ville man kun beregne f(2) en gang og s kende resultatet fremover => frre rekursioner men strre
hukommelsesforbrug!

/Rune
*/

public class Rekursion extends Applet implements ActionListener
{
	public Button start = new Button("Start!");
	public Button slet = new Button("Slet!");
	public TextField a = new TextField("", 5);
	public TextField b = new TextField("", 5);
	public List beregn = new List(20, true);
	public String res = "";
	public long dyna[] = new long[8192];		// fibonacci
	public long dynap[][] = new long[1000][1000];	// pascal

	
	
	public Rekursion()
	{
	}

	public String getAppletInfo()
	{
		return "Name: Rekursion\r\n" +
		       "Author: Rune og Mikael\r\n" +
		       "Created with HardWork++";
	}


	public void init()
	{
		Panel p = new Panel();

    	resize(320, 240);
		setLayout(new BorderLayout());
		add(p, BorderLayout.NORTH);
		add(beregn, BorderLayout.CENTER);
		p.add(start);
		p.add(slet);
		p.add(a);
		p.add(b);
		start.addActionListener(this);
		slet.addActionListener(this);

	}


	// Vlg en af flgende metoder og pas koden til...

/*	public double rek(double x, int p) // potens
	{
		if (p==0)			return (1);
		if( (p & 1)==1 )
		{
			res += (x + "*");
			return (rek(x*x, p/2)*x);
		}

		else				return (rek(x*x, p/2));
	}*/   // end potens

/*	public long rek(int p) //fibonacci
	{
		long x1=0;
		if (dyna[p]!=0)
			x1=dyna[p];
		else
		{
			x1 = (p>2 ? (long) (rek(p-1) + rek(p-2)) : 1);
			dyna[p]=x1;
		};
		res += x1+" ";
		return x1;
	}; */  //end fibonacci

	public long rek(int x, int y) //pascal
	{
		long x1=0;
		if (dynap[x][y]!=0)
			x1=dynap[x][y];
		else
		{
			x1 = ( (y==0 || x==y)? 1 : (rek(x-1,y-1) + rek(x-1,y)) );
			dynap[x][y]=x1;
		};
		res += x1+" ";
		return x1;
	}   // end pascal



	public double beregn(double aa, double bb)
	{
		res ="";
//		return rek(aa, (int) bb);		// tilhrer potens
//		return rek((int)aa);			// tilhrer fibonacci
		return rek((int)aa, (int)bb);	// tilhrer pascal
	}

	public void destroy()
	{
	}

	public void paint(Graphics g)
	{
	}

	public void actionPerformed( ActionEvent e)
	{
		if (e.getSource() == start)
		{
			double x, y;
			x = Double.valueOf(a.getText() ).doubleValue();
			y = Double.valueOf(b.getText() ).doubleValue();
			double z = beregn(x, y);
			beregn.add("" + x + "^" + y + "= " + res + " = " + z);
		}
		if (e.getSource() == slet)
		{
			beregn.removeAll();
		}


	}


	public void start()
	{
	}
	
	public void stop()
	{
	}



}
